#ifndef __Event_h__
#define __Event_h__

#include "IConstSimpleData.h"
#include "String.h"
#include "HeapData.h"

class Event
{
public:
    Event() : _type( -1 )
    {
    }

    Event( unsigned type ) : _type( type )
    {
    }

    void serialize( HeapData &serialized )
    {
        serialized = ConstSimpleData( &_type, sizeof(_type) );
    }

    void deserialize( const IConstSimpleData &serialized )
    {
        memcpy( &_type, serialized.data(), sizeof(unsigned) );
    }

    unsigned type() const
    {
        return _type;
    }

    bool operator==( const Event &other ) const
    {
        return other.type() == type();
    }

    bool operator!=( const Event &other ) const
    {
        return !( other.type() == type() );
    }

    bool operator<( const Event &other ) const
    {
        return type() < other.type();
    }

private:
    unsigned _type;
};

#endif // __Event_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
